//****************************************************************************
//	aisa29s.pas
//
//	aISA-M29
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/07/10
//
//	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
//
//****************************************************************************
unit aisa29s;

interface

uses
	Windows, Messages, SysUtils, Forms, aisa29w;

const
	szTitle = 'Sample';
	szM29	 = 'aISA-M29';

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
	strbuf:	 String;
	dwDLLVer,	 dwDrvVer: DWord;
	bResult:	 Boolean;						// 
	wLogSlot:	 Word;							// foCXi[
	ri:				 TAISA29RESOURCE;	// \[X
	bMode:     Byte;						// [h
	bStatus:   Byte;						// Xe[^X
	dwCountData: DWord;					// JE^f[^
	dwCH1Data:   DWord;					// JXP[hpf[^P
	dwCH2Data:   DWord;					// JXP[hpf[^Q
begin
	//-------------------------------------------------------------------------
	// aisa29.dll J
	//-------------------------------------------------------------------------
	if Aisa29wDllOpen() = False then
	begin
		ErrorMessage(AISA29_SLOT_AUTO);
		Exit;			// aisa29.dll ̃[hɎs܂
	end;

	//-------------------------------------------------------------------------
	// o[W\
	//-------------------------------------------------------------------------
	if Aisa29wGetVersion(dwDLLVer, dwDrvVer) = False then
	begin
		ErrorMessage(AISA29_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('GetVersion'#10 +
					 'DLL Version: %08xH'#10 +
					 'Drv Version: %08xH',
										 [dwDLLVer, dwDrvVer]);

	ResultMessage(strbuf);

	//-------------------------------------------------------------------------
	// aISA-M29 ̎gp錾
	//-------------------------------------------------------------------------
	wLogSlot := AISA29_SLOT_AUTO;		// gp̃foCXT܂B
	bResult := Aisa29wCreate(wLogSlot);	// ꍇA̎̃foCXi[܂B

	if bResult = False then		// foCX܂B
	begin
		ErrorMessage(AISA29_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('aISA-M29 Created'#10#10 +
									 'LogSlot: %2d', [wLogSlot]);

	ResultMessage(strbuf);

	//-------------------------------------------------------------------------
	// \[X擾
	//-------------------------------------------------------------------------
	if Aisa29wGetResource(wLogSlot, @ri) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Board Name: %s'#10 +
									 'IO Base Address: %04xH-%04xH',
										 [szM29, ri.dwIOPortBase[1],
											ri.dwIOPortBase[1] + ri.dwIOPortLength[1]]);

	ResultMessage(strbuf);

	//-------------------------------------------------------------------------
	// [hݒ
	//-------------------------------------------------------------------------
	bMode := 0;
	bMode := bMode
        or AISA29_CH1_CH2_COMPARATE_MODE
        or AISA29_CH2_COMPARATE_MODE
			  or AISA29_CH1_COMPARATE_MODE;
	// CH2 CLEAR MODE = ONE TIME CLEAR MODE
	// CH1 CLEAR MODE = ONE TIME CLEAR MODE
	// CH1:CH2 COMPARETE MODE = 24bit 2i␔r
	// CH2 COMPARETE MODE = 24(48)bit 2i␔r
	// CH1 COMPARATE MODE = 24bit 2i␔r

	if Aisa29wModeSet(wLogSlot, bMode) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('ModeBit: %xH', [bMode]);
	ResultMessage(strbuf);

	//-------------------------------------------------------------------------
	// C-REQ o
	//-------------------------------------------------------------------------
	// C-REQ1
	if Aisa29wCreqWrite(wLogSlot, AISA29_CREQ_1) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	// C-REQ2
	if Aisa29wCreqWrite(wLogSlot, AISA29_CREQ_2) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('C-REQ ɏo܂');

	//-------------------------------------------------------------------------
	// JE^[ CH1 ɃR}ho
	//-------------------------------------------------------------------------

	// QM͂P{JEg[h
	if Aisa29wDataWrite(wLogSlot, AISA29_CH1_2_PHASE_X1_MODE_SET, AISA29_COMMAND_SET_DATA) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('CH1 QM͂P{JEg[h');

	// JE^[Cl[u
	if Aisa29wDataWrite(wLogSlot, AISA29_CH1_COUNT_ENABLE_SET, AISA29_COMMAND_SET_DATA) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('CH1 JE^[Cl[u');

	//-------------------------------------------------------------------------
	// JE^[ CH1 Ƀf[^o
	//-------------------------------------------------------------------------
	dwCountData := 0;
	// 0 Zbg
	if Aisa29wDataWrite(wLogSlot,AISA29_CH1_COUNTER_WRITE, dwCountData) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := 'CH1 CounterWrite'#10#10'0 Zbg܂';
	ResultMessage(strBuf);

	//-------------------------------------------------------------------------
	// Xe[^Xǂݍ
	//-------------------------------------------------------------------------
	if Aisa29wGetStatus(wLogSlot,bStatus) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Status: %xH',[bStatus]);

	ResultMessage(strBuf);

	//-------------------------------------------------------------------------
	// JE^[ CH1 f[^ǂݍ
	//-------------------------------------------------------------------------
	if Aisa29wDataRead(wLogSlot, AISA29_CH1_COUNTER_READ, dwCountData) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('CH1 CounterRead'#10#10'%08xH', [dwCountData]);
	ResultMessage(strBuf);

	//-------------------------------------------------------------------------
	// JXP[ho
	//-------------------------------------------------------------------------
	dwCH1Data := $0;
	dwCH2Data := $0;

	if Aisa29wCascadeWrite(wLogSlot, dwCH1Data, dwCH2Data) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := 'CascadeWrite'#10#10'0 Zbg܂';
	ResultMessage(strBuf);
	//-------------------------------------------------------------------------
	// JXP[hǂݍ
	//-------------------------------------------------------------------------

	if Aisa29wCascadeRead(wLogSlot, dwCH1Data, dwCH2Data) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;
	strbuf := Format('CascadeRead'#10#10 +
									 'CH1 :%08xH'#10 +
									 'CH2 :%08xH',
									 [dwCH1Data,dwCH2Data]);
	ResultMessage(strBuf);

	//-------------------------------------------------------------------------
	// aISA-P31̎gpJ
	//-------------------------------------------------------------------------
	if Aisa29wClose(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('aISA-M29 Closed');

	//-------------------------------------------------------------------------
	// aisa29.dll ̎gpJ
	//-------------------------------------------------------------------------
	if Aisa29wDllClose() = False then
	begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;			// aisa29.dll ̃A[hɎs܂B
	end;

end;

// ʂ\
procedure TForm1.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;

// G[bZ[W\
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	strbuf: String;
begin
	dwRes := Aisa29wGetLastError(wLogSlot);

	case dwRes of
		AISA29_ERR_WRAPDLL:
			strbuf := 'DLL Load error';
	else
		strbuf := Format('aISA-M29 error'#10#10'Error code: %08xH',[dwRes]);
	end;

	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
