//****************************************************************************
//	aisa29w.pas
//
//	aISA-M29
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/03/05
//
//****************************************************************************

unit aisa29w;

interface

uses
	Windows;

const
	AISA29_SLOT_AUTO = $FFFF;
	AISA29_MAX_SLOTS = 16;

{ G[R[h }
const
	AISA29_SUCCESS						   =  0; { ُȂiIj}
	AISA29_ERR_SYSTEM					   =  1; { GetLastError() R[Ă }
	AISA29_ERR_NO_DEVICE				 =  2; { gp\ȃfoCX܂ }
	AISA29_ERR_IN_USE					   =  3; { w̃foCX͎gpł }
	AISA29_ERR_INVALID_SLOT			 =  4; { Ș_Xbgł }
	AISA29_ERR_RESOURCE					 =  5; { \[XG[ }
	AISA29_ERR_INVALID_PORT			 =	6; { sȃ|[gv }
	AISA29_ERR_INVALID_ARGUMENT	 = 	7; { sȈv܂ }
	AISA29_ERR_INVALID_CREQ_PORT = 50; { s CREQ |[gv }
	AISA29_ERR_INVALID_COMMAND	 = 51; { sȃR}hv }
	AISA29_ERR_INVALID_MODE			 = 52; { sȃ[hw肵 }

{ C-REQ ɏރ_~[f[^ }
const
	AISA29_CREQ_DATA				=	$00;

{ R}h|[gւ̃[hݒ莞̃_~[f[^ }
const
	AISA29_COMMAND_SET_DATA	= $00;

{ |[g}
const
	AISA29_MODE_WRITE_PORT		= $04;
	AISA29_STATUS_READ_PORT		= $00;
	AISA29_COMMAND_WRITE_PORT = $00;
	AISA29_CREQ_1_WRITE_PORT	= $06;
	AISA29_CREQ_2_WRITE_PORT	= $07;
	AISA29_DATA_1_PORT				= $01;
	AISA29_DATA_2_PORT				= $02;
	AISA29_DATA_3_PORT				= $03;

{ C-REQ `l }
const
	AISA29_CREQ_1							=	$01;
	AISA29_CREQ_2							= $02;

{ [h }
const
	AISA29_CH2_COUNTER_CLEAR_MODE	= $80;
	AISA29_CH1_COUNTER_CLEAR_MODE	= $40;
	AISA29_CH1_CH2_COMPARATE_MODE	= $20;
	AISA29_CH2_COMPARATE_MODE		  = $10;
	AISA29_CH1_COMPARATE_MODE			= $08;
	AISA29_INTERRUPT_CONTROL_3		= $04;	{ T|[g }
	AISA29_INTERRUPT_CONTROL_2		= $02;	{ T|[g }
	AISA29_INTERRUPT_CONTROL_1		=	$01;	{ T|[g }

{ ݃R}h }
const
	AISA29_CH1_COUNTER_WRITE			 = $00;
	AISA29_CH1_COMPARATOR_WRITE		 = $01;
	AISA29_CH2_COUNTER_WRITE			 = $02;
	AISA29_CH2_COMPARATOR_WRITE		 = $03;
	AISA29_CH1_PRE_SCALER_WRITE		 = $08;
	AISA29_CH2_PRE_SCALER_WRITE		 = $09;
	AISA29_SYNCRONOUS_WRITE				 = $0C;
	AISA29_LEVEL_CLEAR_MODE_SET		 = $0E;
	AISA29_EDGE_CLEAR_MODE_SET		 = $0F;
	AISA29_CH1_PULSE_MODE_SET			 = $10;
	AISA29_CH1_2_PHASE_X1_MODE_SET = $11;
	AISA29_CH1_2_PHASE_X2_MODE_SET = $12;
	AISA29_CH1_2_PHASE_X4_MODE_SET = $13;
	AISA29_CH1_COUNT_ENABLE_SET		 = $14;
	AISA29_CH1_COUNT_DISABLE_SET	 = $15;
	AISA29_SEPARATE_MODE_SET			 = $16;
	AISA29_CASCADE_MODE_SET				 = $17;
	AISA29_CH2_PULSE_MODE_SET			 = $18;
	AISA29_CH2_2_PHASE_X1_MOED_SET = $19;
	AISA29_CH2_2_PHASE_X2_MOED_SET = $1A;
	AISA29_CH2_2_PHASE_X4_MOED_SET = $1B;
	AISA29_CH2_COUNT_ENABLE_SET		 = $1C;
	AISA29_CH2_COUNT_DISABLE_SET	 = $1D;

{ ǂݍ݃R}h }
const
	AISA29_CH1_COUNTER_READ				 = $04;
	AISA29_CH1_COMPARATOR_READ		 = $05;
	AISA29_CH2_COUNTER_READ				 = $06;
	AISA29_CH2_COMPARATOR_READ		 = $07;
	AISA29_CH1_PRE_SCALER_READ		 = $0A;
	AISA29_CH2_PRE_SCALER_READ		 = $0B;
	AISA29_SYNCRONOUS_READ				 = $0D;

{ \[X\ }
const
	AISA29_MAX_MEM = 9;		{ number of memory windows }
	AISA29_MAX_IO	 = 20;	{ number of i/o windows }
	AISA29_MAX_IRQ = 7;		{ number of irqs }
	AISA29_MAX_DMA = 7;		{ number of dmas }

type
	TAISA29RESOURCE = record
		dwNumMemWindows: DWord;																{ Not used }
		dwMemBase:			array [1 .. AISA29_MAX_MEM] of DWord; { Not used }
		dwMemLength:		array [1 .. AISA29_MAX_MEM] of DWord;	{ Not used }
		dwMemAttrib:		array [1 .. AISA29_MAX_MEM] of DWord;	{ Not used }
		dwNumIOPorts:		DWord;																{ Num IO ports }
		dwIOPortBase:		array [1 .. AISA29_MAX_IO] of DWord;	{ I/O port base }
		dwIOPortLength: array [1 .. AISA29_MAX_IO] of DWord;	{ I/O port length }
		dwNumIRQs:			DWord;																{ Num IRQ info }
		dwIRQRegisters: array [1 .. AISA29_MAX_IRQ] of DWord;	{ IRQ list }
		dwIRQAttrib:		array [1 .. AISA29_MAX_IRQ] of DWord;	{ IRQ Attrib list }
		dwNumDMAs:			DWord;																{ Not used }
		dwDMALst:				array [1 .. AISA29_MAX_DMA] of DWord;	{ Not used }
		dwDMAAttrib:		array [1 .. AISA29_MAX_DMA] of DWord;	{ Not used }
		dwReserved1:		array [1 .. 3]							of DWord; {	Not used }
	end;

PAISA29R = ^TAISA29RESOURCE;

const
	AISA29_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	AISA29_DLL_NAME = 'aisa29.dll';	{ DLL }


function Aisa29wDllOpen: Boolean;		{ DLL [h }
function Aisa29wDllClose: Boolean;	{ DLL A[h }


function Aisa29wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
function Aisa29wCreate(var pwLogSlot: Word): Boolean;
function Aisa29wClose(wLogSlot: Word): Boolean;

function Aisa29wGetResource(wLogSlot: Word; pres: PAISA29R): Boolean;

function Aisa29wModeSet(wLogSlot: Word; bMode: Byte): Boolean;
function Aisa29wCreqWrite(wLogSlot: Word; wCreq: Word): Boolean;
function Aisa29wGetStatus(wLogSlot: Word; var pbStatus: Byte): Boolean;
function Aisa29wDataWrite(wLogSlot: Word; bCmd: Byte; dwData: DWord): Boolean;
function Aisa29wDataRead(wLogSlot: Word; bCmd: Byte; var pdwData: DWord): Boolean;
function Aisa29wCascadeWrite(wLogSlot: Word; dwCh1Data: DWord; dwCh2Data: DWord): Boolean;
function Aisa29wCascadeRead(wLogSlot: Word; var pdwCh1Data: DWord; var pdwCh2Data: DWord): Boolean;

function Aisa29wGetLastError(wLogSlot: Word): DWord;


implementation

type
	TAisa29GetVersion = function(var pdwDllVer: DWord; var pdwDrvVer: DWord): Bool; stdcall;
	TAisa29Create = function(var pwLogSlot: Word): Bool; stdcall;
	TAisa29Close = function(wLogSlot: Word): Bool; stdcall;
	TAisa29GetResource = function(wLogSlot: Word; pres: PAISA29R): Bool; stdcall;
	TAisa29ModeSet = function(wLogSlot: Word; bMode: Byte): Bool; stdcall;
	TAisa29CreqWrite = function(wLogSlot: Word; wCreq: Word): Bool; stdcall;
  TAisa29GetStatus = function(wLogSlot: Word; var pbStatus: Byte): Bool; stdcall;
  TAisa29DataWrite = function(wLogSlot: Word; bCmd: Byte; dwData: DWord): Bool; stdcall;
	TAisa29DataRead = function(wLogSlot: Word; bCmd: Byte; var pdwData: DWord): Bool; stdcall;
	TAisa29CascadeWrite = function(wLogSlot: Word; dwCh1Data: DWord; dwCh2Data: DWord): Bool; stdcall;
	TAisa29CascadeRead = function(wLogSlot: Word; var pdwCh1Data: DWord; var pdwCh2Data: DWord): Bool; stdcall;
	TAisa29GetLastError = function(wLogSlot: Word): DWord; stdcall;

function Aisa29wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

{ DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa29GetVersion: TAisa29GetVersion;
	pAisa29Create: TAisa29Create;
	pAisa29Close: TAisa29Close;
	pAisa29GetResource: TAisa29GetResource;
	pAisa29ModeSet: TAisa29ModeSet;
	pAisa29CreqWrite: TAisa29CreqWrite;
  pAisa29GetStatus: TAisa29GetStatus;
  pAisa29DataWrite: TAisa29DataWrite;
	pAisa29DataRead: TAisa29DataRead;
	pAisa29CascadeWrite: TAisa29CascadeWrite;
	pAisa29CascadeRead: TAisa29CascadeRead;
	pAisa29GetLastError: TAisa29GetLastError;


//****************************************************************************
// @\  aisa29.dll[h
//   Ȃ
// ߒl  True  --- 
//       False --- s
//****************************************************************************
function Aisa29wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA29_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa29wGetDllExportFunc = False then
	begin
		Aisa29wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Exit;
	end;

	Result := True;
end;

//****************************************************************************
// @\  aisa29.dllA[h
//   Ȃ
// ߒl  True  --- 
//       False --- s
//****************************************************************************
function Aisa29wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;



//****************************************************************************
// @\  aISA-M29̃o[Wԍ擾
//   pdwDllVer --- DLLo[Wԍi[AhX
//       pdwDrvVer --- DRVo[Wԍi[AhX
// ߒl  True      --- 
//       False     --- s
//****************************************************************************
function Aisa29wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa29GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// @\  aISA-M29̔Cӂ̃foCX̎gp錾
//   pwLogSlot  --- gpfoCXi[AhX
// ߒl  True       --- 
//       False      --- s
//****************************************************************************
function Aisa29wCreate(var pwLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa29Create(pwLogSlot);
end;

//****************************************************************************
// @\  aISA-M29̔Cӂ̃foCX̎gpJ
//   wLogSlot  --- gpfoCX
// ߒl  True      --- 
//       False     --- s
//****************************************************************************
function Aisa29wClose(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa29Close(wLogSlot);
end;

//****************************************************************************
// @\  wfoCX̃\[X擾
//   wLogSlot --- ׂfoCX
//       pResInfo --- \[Xi[\̂̃AhX
// ߒl  True     --- 
//       False    --- s
//****************************************************************************
function Aisa29wGetResource(wLogSlot: Word; pres: PAISA29R): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa29GetResource(wLogSlot, pres);
end;

//****************************************************************************
// @\  [hZbg
//   wLogSlot --- ݒ肷foCX
//       bMode    --- [h
// ߒl  TRrue    --- 
//       Fasle    --- s
//****************************************************************************
function Aisa29wModeSet(wLogSlot: Word; bMode: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa29ModeSet(wLogSlot, bMode);
end;

//****************************************************************************
// @\  C-REQ |[g֏
//   wLogSlot --- ݂foCX
//       wCreq    --- C-REQ `l ( AISA29_CREQ_1 ܂ AISA29_CREQ_2 )
// ߒl  True     --- 
//       False    --- s
//****************************************************************************
function Aisa29wCreqWrite(wLogSlot: Word; wCreq: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa29CreqWrite(wLogSlot, wCreq);
end;

//****************************************************************************
// @\  Xe[^Xǂݍ
//   wLogSlot --- ǂݍ݂foCX
//       wCreq    --- Xe[^Xi[̈ւ̃|C^
// ߒl  True     --- 
//       False    --- s
//****************************************************************************
function Aisa29wGetStatus(wLogSlot: Word; var pbStatus: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

  Result := pAisa29GetStatus(wLogSlot, pbStatus);
end;

//****************************************************************************
// @\  f[^
//   wLogSlot --- ݂foCX
//       bCmd     --- R}h
//       dwData   --- f[^
// ߒl  True     --- 
//       False    --- s
//****************************************************************************
function Aisa29wDataWrite(wLogSlot: Word; bCmd: Byte; dwData: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

  Result := pAisa29DataWrite(wLogSlot, bCmd, dwData);
end;

//****************************************************************************
// @\  f[^ǂݍ
//   wLogSlot --- ǂݍ݂foCX
//       bCmd     --- R}h
//       dwData   --- f[^i[̈ւ̃|C^
// ߒl  TRUE     --- 
//       FALSE    --- s
//****************************************************************************
function Aisa29wDataRead(wLogSlot: Word; bCmd: Byte; var pdwData: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa29DataRead(wLogSlot, bCmd, pdwData);
end;

//****************************************************************************
// @\  JXP[h
//   wLogSlot --- ݂foCX
//       dwCh1Data--- `lPɏރf[^
//       dwCh2Data--- `lQɏރf[^
// ߒl  True     --- 
//       False    --- s
//****************************************************************************
function Aisa29wCascadeWrite(wLogSlot: Word; dwCh1Data: DWord; dwCh2Data: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa29CascadeWrite(wLogSlot, dwCh1Data, dwCh2Data);
end;

//****************************************************************************
// @\  JXP[hǂݍ
//   wLogSlot --- ǂݍ݂foCX
//       dwCh1Data--- `lPf[^i[̈ւ̃|C^
//       dwCh2Data--- `lQf[^i[̈ւ̃|C^
// ߒl  True     --- 
//       False    --- s
//****************************************************************************
function Aisa29wCascadeRead(wLogSlot: Word; var pdwCh1Data: DWord; var pdwCh2Data: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa29CascadeRead(wLogSlot, pdwCh1Data, pdwCh2Data);
end;

//****************************************************************************
// @\  aISA-M29̃G[R[h
//   wLogSlot  --- G[foCX
// ߒl  True      --- 
//       False     --- s
//****************************************************************************
function Aisa29wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA29_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa29GetLastError(wLogSlot);
end;

//---------------------------------------------------------------------------
// 		DLLGNX|[g֐AhX̎擾
// 		
// ߂l  True
//				s False
//---------------------------------------------------------------------------
function Aisa29wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Aisa29GetVersion ̃AhX擾
	pAisa29GetVersion := GetProcAddress(hDLL, 'Aisa29GetVersion');
	if @pAisa29GetVersion = nil then Exit;

	// Aisa29Create ̃AhX擾
	pAisa29Create := GetProcAddress(hDLL, 'Aisa29Create');
	if @pAisa29Create = nil then Exit;

	// Aisa29Close ̃AhX擾
	pAisa29Close := GetProcAddress(hDLL, 'Aisa29Close');
	if @pAisa29Close = nil then Exit;

	// Aisa29GetResource ̃AhX擾
	pAisa29GetResource := GetProcAddress(hDLL, 'Aisa29GetResource');
	if @pAisa29GetResource = nil then Exit;

	// Aisa29ModeSet ̃AhX擾
	pAisa29ModeSet := GetProcAddress(hDLL, 'Aisa29ModeSet');
	if @pAisa29ModeSet = nil then Exit;

	// Aisa29CreqWrite ̃AhX擾
	pAisa29CreqWrite := GetProcAddress(hDLL, 'Aisa29CreqWrite');
	if @pAisa29CreqWrite = nil then Exit;

 	// Aisa29GetStatus ̃AhX擾
	pAisa29GetStatus := GetProcAddress(hDLL, 'Aisa29GetStatus');
	if @pAisa29GetStatus = nil then Exit;

	// Aisa29DataWrite ̃AhX擾
	pAisa29DataWrite := GetProcAddress(hDLL, 'Aisa29DataWrite');
	if @pAisa29DataWrite = nil then Exit;

	// Aisa29DataRead ̃AhX擾
	pAisa29DataRead := GetProcAddress(hDLL, 'Aisa29DataRead');
	if @pAisa29DataRead = nil then Exit;

	// Aisa29CascadeWrite ̃AhX擾
	pAisa29CascadeWrite := GetProcAddress(hDLL, 'Aisa29CascadeWrite');
	if @pAisa29CascadeWrite = nil then Exit;

	//  ̃AhX擾
	pAisa29CascadeRead := GetProcAddress(hDLL, 'Aisa29CascadeRead');
	if @pAisa29CascadeRead = nil then Exit;

	// Aisa29GetLastError ̃AhX擾
	pAisa29GetLastError := GetProcAddress(hDLL, 'Aisa29GetLastError');
	if @pAisa29GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

