#ifndef _AISA29_H_
#define _AISA29_H_	0x7029

#ifdef __cplusplus
extern "C" {
#endif

#define AISA29_SLOT_AUTO	0xFFFF
#define AISA29_MAX_SLOTS	16

/* G[R[h */
#define AISA29_SUCCESS						0	/* ُȂiIj */
#define AISA29_ERR_SYSTEM					1	/* GetLastError() R[Ă */
#define AISA29_ERR_NO_DEVICE				2	/* gp\ȃfoCX܂ */
#define AISA29_ERR_IN_USE					3	/* w̃foCX͎gpł */
#define AISA29_ERR_INVALID_SLOT				4	/* Ș_Xbgł */
#define AISA29_ERR_RESOURCE					5	/* \[XG[ */
#define AISA29_ERR_INVALID_PORT				6	/* sȃ|[gv */
#define AISA29_ERR_INVALID_ARGUMENT			7	/* sȈv܂ */
#define AISA29_ERR_INVALID_CREQ_PORT		50	/* s CREQ |[gv */
#define AISA29_ERR_INVALID_COMMAND			51	/* sȃR}hv */
#define AISA29_ERR_INVALID_MODE				52	/* sȃ[hw肵 */

/* C-REQ ɏރ_~[f[^ */
#define AISA29_CREQ_DATA					0x00

/* R}h|[gւ̃[hݒ莞̃_~[f[^ */
#define AISA29_COMMAND_SET_DATA				0x00

/* |[g */
#define AISA29_MODE_WRITE_PORT				0x04
#define AISA29_STATUS_READ_PORT				0x00
#define AISA29_COMMAND_WRITE_PORT			0x00
#define AISA29_CREQ_1_WRITE_PORT			0x06
#define AISA29_CREQ_2_WRITE_PORT			0x07
#define AISA29_DATA_1_PORT					0x01
#define AISA29_DATA_2_PORT					0x02
#define AISA29_DATA_3_PORT					0x03

/* C-REQ `l */
#define AISA29_CREQ_1						0x01
#define AISA29_CREQ_2						0x02

/* [h */
#define AISA29_CH2_COUNTER_CLEAR_MODE		0x80
#define AISA29_CH1_COUNTER_CLEAR_MODE		0x40
#define AISA29_CH1_CH2_COMPARATE_MODE		0x20
#define AISA29_CH2_COMPARATE_MODE			0x10
#define AISA29_CH1_COMPARATE_MODE			0x08
#define AISA29_INTERRUPT_CONTROL_3			0x04	/* T|[g */
#define AISA29_INTERRUPT_CONTROL_2			0x02	/* T|[g */
#define AISA29_INTERRUPT_CONTROL_1			0x01	/* T|[g */

/* ݃R}h */
#define AISA29_CH1_COUNTER_WRITE			0x00
#define AISA29_CH1_COMPARATOR_WRITE			0x01
#define AISA29_CH2_COUNTER_WRITE			0x02
#define AISA29_CH2_COMPARATOR_WRITE			0x03
#define AISA29_CH1_PRE_SCALER_WRITE			0x08
#define AISA29_CH2_PRE_SCALER_WRITE			0x09
#define AISA29_SYNCRONOUS_WRITE				0x0C
#define AISA29_LEVEL_CLEAR_MODE_SET			0x0E
#define AISA29_EDGE_CLEAR_MODE_SET			0x0F
#define AISA29_CH1_PULSE_MODE_SET			0x10
#define AISA29_CH1_2_PHASE_X1_MODE_SET		0x11
#define AISA29_CH1_2_PHASE_X2_MODE_SET		0x12
#define AISA29_CH1_2_PHASE_X4_MODE_SET		0x13
#define AISA29_CH1_COUNT_ENABLE_SET			0x14
#define AISA29_CH1_COUNT_DISABLE_SET		0x15
#define AISA29_SEPARATE_MODE_SET			0x16
#define AISA29_CASCADE_MODE_SET				0x17
#define AISA29_CH2_PULSE_MODE_SET			0x18
#define AISA29_CH2_2_PHASE_X1_MOED_SET		0x19
#define AISA29_CH2_2_PHASE_X2_MOED_SET		0x1A
#define AISA29_CH2_2_PHASE_X4_MOED_SET		0x1B
#define AISA29_CH2_COUNT_ENABLE_SET			0x1C
#define AISA29_CH2_COUNT_DISABLE_SET		0x1D

/* ǂݍ݃R}h */
#define AISA29_CH1_COUNTER_READ				0x04
#define AISA29_CH1_COMPARATOR_READ			0x05
#define AISA29_CH2_COUNTER_READ				0x06
#define AISA29_CH2_COMPARATOR_READ			0x07
#define AISA29_CH1_PRE_SCALER_READ			0x0A
#define AISA29_CH2_PRE_SCALER_READ			0x0B
#define AISA29_SYNCRONOUS_READ				0x0D

/* \[X\ */
#define AISA29_MAX_MEM  9
#define AISA29_MAX_IO   20
#define AISA29_MAX_IRQ  7
#define AISA29_MAX_DMA  7

typedef struct _AISA29RESOURCE {
    DWORD   dwNumMemWindows;                    // Not used
    DWORD   dwMemBase       [AISA29_MAX_MEM];   // Not used
    DWORD   dwMemLength     [AISA29_MAX_MEM];   // Not used
    DWORD   dwMemAttrib     [AISA29_MAX_MEM];   // Not used
    DWORD   dwNumIOPorts;                       // Num IO ports
    DWORD   dwIOPortBase    [AISA29_MAX_IO];    // I/O port base
    DWORD   dwIOPortLength  [AISA29_MAX_IO];    // I/O port length
    DWORD   dwNumIRQs;                          // Not used
    DWORD   dwIRQRegisters  [AISA29_MAX_IRQ];   // Not used
    DWORD   dwIRQAttrib     [AISA29_MAX_IRQ];   // Not used
	DWORD	dwNumDMAs;							// Not used
    DWORD   dwDMALst        [AISA29_MAX_DMA];   // Not used
    DWORD   dwDMAAttrib     [AISA29_MAX_DMA];   // Not used
    DWORD   dwReserved1     [3];                // Not used
} AISA29RESOURCE, *PAISA29R;

#ifndef	AISA29_DS
#define	AISA29_DS	__declspec(dllimport)
#endif

AISA29_DS
BOOL 	WINAPI Aisa29GetVersion( PDWORD pdwDllVersion, PDWORD pdwDrvVersion);
AISA29_DS
BOOL	WINAPI Aisa29Create( PWORD pwLogSlot );
AISA29_DS
BOOL 	WINAPI Aisa29Close(WORD wLogSlot);
AISA29_DS
BOOL	WINAPI Aisa29GetResource(WORD wLogSlot, PAISA29R pres);
AISA29_DS
BOOL 	WINAPI Aisa29ModeSet( WORD wLogSlot, BYTE bMode );
AISA29_DS
BOOL 	WINAPI Aisa29CreqWrite( WORD wLogSlot, WORD wCreq );
AISA29_DS
BOOL 	WINAPI Aisa29GetStatus( WORD wLogSlot, PBYTE pbStatus );
AISA29_DS
BOOL 	WINAPI Aisa29DataWrite( WORD wLogSlot, BYTE bCmd, DWORD dwData );
AISA29_DS
BOOL 	WINAPI Aisa29DataRead( WORD wLogSlot, BYTE bCmd, PDWORD pdwData );
AISA29_DS
BOOL 	WINAPI Aisa29CascadeWrite( WORD wLogSlot, DWORD dwCh1Data, DWORD dwCh2Data );
AISA29_DS
BOOL 	WINAPI Aisa29CascadeRead( WORD wLogSlot, PDWORD pdwCh1Data, PDWORD pdwCh2Data );
AISA29_DS
DWORD 	WINAPI Aisa29GetLastError(WORD wLogSlot);

#ifdef __cplusplus
}
#endif
#endif	/* _AISA29_H_ */
